#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fun>
#include "include/clanwar_const"
#include "include/clanwar_core"

new g_cw_EventGame, g_cw_EventError, g_cw_EventReturn

new g_cw_conf_dir, g_cw_clantag
new g_cw_half_rounds, g_cw_half_timeout, g_cw_assign_mode, g_cw_warmup_limit
new g_cw_overtime, g_cw_overtime_rounds, g_cw_overtime_timeout
new g_cw_team_sort, g_cw_transfer_model, g_cw_transfer_timeout, g_cw_restart

new game_status, half_status, overtime_status, half_number
new team_name[2][32], team_captain[2], team_score[2][4]/*0-Total 1-First 2-Second 3-Overtime*/, team_side[2] /*0-CT  1-TER*/
new assign_team, assign_swap
new timeout_time, wait_restarts
new transfer_players[2][32], transfer_count[2], CsInternalModel:transfer_model[2][4]

//----------------------------------------------------------------------------------
//------------------------------------[ CMDs ]--------------------------------------
//----------------------------------------------------------------------------------
public Core_GameBegin(id, level, cid)
{
 if(!cmd_access(id, level, cid, 1)) return PLUGIN_HANDLED
 //--
 if(game_status != GAME_NULL)
  {
   ExecuteForward(g_cw_EventError, g_cw_EventReturn, CWE_ERROR_INIT_ALREADY, id)
   return PLUGIN_HANDLED
  }
 //--
 read_argv(1, team_name[0], 31)
 read_argv(2, team_name[1], 31)
 
 if((strlen(team_name[0]) <= 0) || (strlen(team_name[1]) <= 0) || (equali(team_name[0], team_name[1]) != 0))
  {
   ExecuteForward(g_cw_EventError, g_cw_EventReturn, CWE_ERROR_INIT_PARAMS, id)
   return PLUGIN_HANDLED
  }
 
 team_captain	= {0, 0}
 team_side		= {0, 1}
 team_score[0]	= {0, 0, 0, 0}
 team_score[1]	= {0, 0, 0, 0}
 assign_team		= -1
 assign_swap		= -1
 transfer_count	= {0, 0}
 
 game_status		= GAME_NULL
 half_status		= HALF_NULL
 overtime_status	= OVERTIME_NULL
 
 if(get_pcvar_num(g_cw_team_sort) != 0)
  {
   Core_Transfer_TeamSort(team_name[0], team_name[1])
  }
 
 //--
 new players[32], players_count
 
 get_players(players, players_count, "e", "CT")
 if(players_count > 0) team_captain[0] = players[random(players_count)]
  
 get_players(players, players_count, "e", "TERRORIST")
 if(players_count > 0) team_captain[1] = players[random(players_count)]
 //--
 
 cw_exec_config("cw_server_clanwar.cfg")
 ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_INIT, 0)
 
 Core_GameChange()
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
public Core_GameForce(id, level, cid)
{
 if(!cmd_access(id, level, cid, 1)) return PLUGIN_HANDLED
 //--
 if((game_status == GAME_NULL) || (game_status == GAME_HALF_KNIFE) || ((game_status != GAME_HALF_WARMUP) && (half_status != HALF_NULL)))
  {
   ExecuteForward(g_cw_EventError, g_cw_EventReturn, CWE_ERROR_FORCE, id)
   return PLUGIN_HANDLED
  }
 
 ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_FORCE, id)
 Core_GameChange()
  
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
public Core_GameRestart(id, level, cid)
{
 if(!cmd_access(id, level, cid, 1)) return PLUGIN_HANDLED
 //--
 if(game_status == GAME_NULL)
  {
   ExecuteForward(g_cw_EventError, g_cw_EventReturn, CWE_ERROR_RESTART_GAME, id)
   return PLUGIN_HANDLED
  }
 
 if(task_exists(TASK_TIMEOUT_TIMER)) remove_task(TASK_TIMEOUT_TIMER)
 
 //-- Restore sides
 if((half_number > 0) && (((assign_swap != 1) && ((half_number % 2) == 0)) || ((assign_swap == 1) && ((half_number % 2) != 0))))
  {
   Core_Transfer_Init()
   Core_Transfer_Do(true)
  }
 
 team_side		= {0, 1}
 team_score[0]	= {0, 0, 0, 0}
 team_score[1]	= {0, 0, 0, 0}
 assign_team		= -1
 assign_swap		= -1
 transfer_count	= {0, 0}
 
 game_status		= GAME_NULL
 half_status		= HALF_NULL
 overtime_status	= OVERTIME_NULL
  
 if(get_pcvar_num(g_cw_team_sort) != 0)
  {
   Core_Transfer_TeamSort(team_name[0], team_name[1])
  }
 
 Core_RestartRound("1")
 
 cw_exec_config("cw_server_clanwar.cfg")
 ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_RESTART, 0)
  
 Core_GameChange()
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
public Core_GameRestartHalf(id, level, cid)
{
 if(!cmd_access(id, level, cid, 1)) return PLUGIN_HANDLED
 //--
 if((game_status == GAME_NULL) || (half_status != HALF_ACTIVE))
  {
   ExecuteForward(g_cw_EventError, g_cw_EventReturn, CWE_ERROR_RESTART_HALF, id)
   return PLUGIN_HANDLED
  }
 
 if(task_exists(TASK_TIMEOUT_TIMER)) remove_task(TASK_TIMEOUT_TIMER)
 
 team_score[0][half_number]	= 0
 team_score[1][half_number]	= 0
 half_status				= HALF_NULL
 transfer_count			= {0, 0}
 if(game_status == GAME_HALF_KNIFE)
  {
   assign_team			= -1
   assign_swap			= -1
  }
 game_status				= game_status - 1
 
 ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_RESTART_HALF, 0)
 Core_GameChange()
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
public Core_GameAbort(id, level, cid)
{
 if(!cmd_access(id, level, cid, 1)) return PLUGIN_HANDLED
 //--
 if(game_status == GAME_NULL)
  {
   ExecuteForward(g_cw_EventError, g_cw_EventReturn, CWE_ERROR_ABORT, id)
   return PLUGIN_HANDLED
  }
 
 Core_GameEnd()
 ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_ABORT, id)
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
Core_GameEnd()
{
 if(task_exists(TASK_TIMEOUT_TIMER)) remove_task(TASK_TIMEOUT_TIMER)
 
 game_status		= GAME_NULL
 half_status		= HALF_NULL
 overtime_status	= OVERTIME_NULL
 
 cw_exec_config("cw_server_public.cfg")
}
//----------------------------------------------------------------------------------
//-------------------------------[  CORE FUNCTIONs ]--------------------------------
//----------------------------------------------------------------------------------
public Core_GameChange()
{
 switch(game_status)
  {
   //---------------------------
   case GAME_NULL:
    {
     ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_INIT, GAME_HALF_WARMUP)
     set_task(TIMEOUT_HALF_INIT, "Core_Task_HalfBegin_Warmup")
    }
   //---------------------------
   case GAME_HALF_WARMUP:
    {
     if(task_exists(TASK_TIMEOUT_TIMER)) remove_task(TASK_TIMEOUT_TIMER)
     
     half_status = HALF_NULL
     ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_END, GAME_HALF_WARMUP)
     
     if(get_pcvar_num(g_cw_assign_mode) == 1)
      {
       ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_INIT, GAME_HALF_KNIFE)
       set_task(TIMEOUT_HALF_INIT, "Core_Task_HalfBegin_Knife")
      }
     else
      {
       ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_INIT, GAME_HALF_FIRST)
       set_task(TIMEOUT_HALF_INIT, "Core_Task_HalfBegin_First")
      }
    }
   //---------------------------
   case GAME_HALF_KNIFE:
    {
     if((half_status == HALF_ACTIVE) && (assign_team != -1))
      {
       half_status = HALF_NULL
       ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_END, GAME_HALF_KNIFE)
       
       Core_Menu_StartSide_Show()
      }
     else if(assign_swap != -1)
      {
       if(assign_swap == 1)
        {
         Core_Transfer_Do(true)
        }
       
       ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_INIT, GAME_HALF_FIRST)
       set_task(TIMEOUT_HALF_INIT, "Core_Task_HalfBegin_First")
      }
    }
   //---------------------------
   case GAME_HALF_FIRST:
    {
     if(half_status == HALF_ACTIVE)
      {
       half_status = HALF_NULL
       ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_END, GAME_HALF_FIRST)
       
       Core_Transfer_Do()
       
       timeout_time = floatround(get_pcvar_float(g_cw_half_timeout) * 60)
       set_task(1.0, "Core_Task_TimeoutTimer", TASK_TIMEOUT_TIMER, "", 0, "b")
      }
     else
      {
       if(task_exists(TASK_TIMEOUT_TIMER)) remove_task(TASK_TIMEOUT_TIMER)
       
       ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_INIT, GAME_HALF_SECOND)
       set_task(TIMEOUT_HALF_INIT, "Core_Task_HalfBegin_Second")
      }
    }
   //---------------------------
   case GAME_HALF_SECOND:
    {
     if(half_status == HALF_ACTIVE)
      {
       half_status = HALF_NULL
       ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_END, GAME_HALF_SECOND)
       //--
       new half_rounds = get_pcvar_num(g_cw_half_rounds)
       
       if(team_score[0][0] == (half_rounds + 1))		//-- 1st Team Won
        {
         ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_END, (team_side[0] == 0) ? 0:1)
         Core_GameEnd()
        }
       else if(team_score[1][0] == (half_rounds + 1))	//-- 2nd Team Won
        {
         ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_END, (team_side[0] == 1) ? 0:1)
         Core_GameEnd()
        }
       else if((team_score[0][0] == half_rounds) && (team_score[1][0] == half_rounds))
        {
         if(get_pcvar_num(g_cw_overtime) == 0)		//-- Game Draw
          {
           ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_END, -1)
           Core_GameEnd()
          }
         else							//-- Overtime
          {
           Core_Transfer_Do()
           
           game_status	= GAME_HALF_OVERTIME
           overtime_status	= OVERTIME_NULL
           
           timeout_time = floatround(get_pcvar_float(g_cw_overtime_timeout) * 60)
           set_task(1.0, "Core_Task_TimeoutTimer", TASK_TIMEOUT_TIMER, "", 0, "b")
          }
        }
      }
    }
   //---------------------------
   case GAME_HALF_OVERTIME:
    {
     switch(overtime_status)
      {
       case OVERTIME_NULL:					//-- Overtime Begin
        {
         if(task_exists(TASK_TIMEOUT_TIMER)) remove_task(TASK_TIMEOUT_TIMER)
         
         overtime_status	= OVERTIME_HALF_FIRST
         team_score[0][3]	= 0
         team_score[1][3]	= 0
         
         ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_INIT, GAME_HALF_OVERTIME)
         set_task(TIMEOUT_HALF_INIT, "Core_Task_HalfBegin_Overtime")
        }
       case OVERTIME_HALF_FIRST:
        {
         if(half_status == HALF_ACTIVE)
          {
           half_status = HALF_NULL
           ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_END, GAME_HALF_OVERTIME)
           
           Core_Transfer_Do()
           
           timeout_time = floatround(get_pcvar_float(g_cw_half_timeout) * 60)
           set_task(1.0, "Core_Task_TimeoutTimer", TASK_TIMEOUT_TIMER, "", 0, "b")
          }
         else						//-- Go 2nd Overtime Half
          {
           if(task_exists(TASK_TIMEOUT_TIMER)) remove_task(TASK_TIMEOUT_TIMER)
           
           overtime_status = OVERTIME_HALF_SECOND
           
           ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_INIT, GAME_HALF_OVERTIME)
           set_task(TIMEOUT_HALF_INIT, "Core_Task_HalfBegin_Overtime")
          }
        }
       case OVERTIME_HALF_SECOND:				//-- 2nd Overtime Half
        {
         new overtime_rounds = get_pcvar_num(g_cw_overtime_rounds)
         
         if(team_score[0][3] == (overtime_rounds + 1))		//-- 1st Team Won
          {
           ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_END, (team_side[0] == 0) ? 0:1)
           Core_GameEnd()
          }
         else if(team_score[1][3] == (overtime_rounds + 1))	//-- 2nd Team Won
          {
           ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_END, (team_side[0] == 1) ? 0:1)
           Core_GameEnd()
          }
         else if((team_score[0][3] == overtime_rounds) && (team_score[1][3] == overtime_rounds)) //-- Loop Overtime
          {
           Core_Transfer_Do()
           
           overtime_status	= OVERTIME_NULL
           
           timeout_time = floatround(get_pcvar_float(g_cw_overtime_timeout) * 60)
           set_task(1.0, "Core_Task_TimeoutTimer", TASK_TIMEOUT_TIMER, "", 0, "b")
          }
        }
      }
    }
   //---------------------------
  }
}
//----------------------------------------------------------------------------------
public Core_HalfChange()
{
 switch(game_status)
  {
   case GAME_HALF_WARMUP:
    {
     timeout_time	= floatround(get_pcvar_float(g_cw_warmup_limit) * 60)
     if(timeout_time > 1)
      {
       set_task(1.0, "Core_Task_TimeoutTimer", TASK_TIMEOUT_TIMER, "", 0, "b")
      }
     
     half_status	= HALF_ACTIVE
     ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_STARTED, GAME_HALF_WARMUP)
    }
   case GAME_HALF_KNIFE:
    {
     Core_Transfer_Init()
     Core_StripWeapons()
     
     half_status	= HALF_ACTIVE
     ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_STARTED, GAME_HALF_KNIFE)
    }
   case GAME_HALF_FIRST:
    {
     half_status	= HALF_ACTIVE
     ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_STARTED, GAME_HALF_FIRST)
    }
   case GAME_HALF_SECOND:
    {
     half_status	= HALF_ACTIVE
     ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_STARTED, GAME_HALF_SECOND)
    }
   case GAME_HALF_OVERTIME:
    {
     half_status	= HALF_ACTIVE
     ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_STARTED, GAME_HALF_OVERTIME)
    }
  }
}
//----------------------------------------------------------------------------------
Core_ScoreChange(scr_team)
{
 new half_rounds		= get_pcvar_num(g_cw_half_rounds)
 new overtime_rounds	= get_pcvar_num(g_cw_overtime_rounds)
 
 switch(game_status)
  {
   //------------------------
   case GAME_HALF_KNIFE:
    {
     if(half_status == HALF_ACTIVE)
      {
       assign_team = scr_team
       Core_GameChange()
      }
     else if(assign_team != -1)
      {
       Core_Menu_StartSide_Show()
      }
    }
   //------------------------
   case GAME_HALF_FIRST:
    {
     if(half_status == HALF_ACTIVE)
      {
       team_score[scr_team][1]++
       team_score[scr_team][0]++
       
       if((team_score[0][1] + team_score[1][1]) == (half_rounds - 1))		//-- Begin Swap
        {
         Core_Transfer_Init()
        }
       else if((team_score[0][1] + team_score[1][1]) == half_rounds)		//-- Go 2nd half
        {
         ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_SCORE_CHANGED, 1)
         Core_GameChange()
         return //-- break
        }
       
       ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_SCORE_CHANGED, 0)
      }
    }
   //------------------------
   case GAME_HALF_SECOND:
    {
     client_print(0, print_chat, "[DEBUG] WIN> HalfStatus: %d Team: %d Total:%d CurHalf: %d", half_status, scr_team, team_score[scr_team][0], team_score[scr_team][2]);
     if(half_status == HALF_ACTIVE)
      {
       team_score[scr_team][2]++
       team_score[scr_team][0]++
        
       if((team_score[0][2] + team_score[1][2]) == (half_rounds - 1))	//-- Begin Swap
        {
         Core_Transfer_Init()
        }
       else if((team_score[0][0] == (half_rounds + 1)) || (team_score[1][0] == (half_rounds + 1)) ||
              ((team_score[0][0] == half_rounds) && (team_score[1][0] == half_rounds)))
        {
         ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_SCORE_CHANGED, 1)
         Core_GameChange()
         return //-- break
        }
       
       ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_SCORE_CHANGED, 0)
      }
    }
   //------------------------
   case GAME_HALF_OVERTIME:
    {
     if(half_status == HALF_ACTIVE)
      {
       team_score[scr_team][3]++
       team_score[scr_team][0]++
       
       switch(overtime_status)
        {
         case OVERTIME_HALF_FIRST:								//-- 1st Overtime Half
          {
           if((team_score[0][3] + team_score[1][3]) == (overtime_rounds - 1))	//-- Begin Swap
            {
             Core_Transfer_Init()
            }
           else if((team_score[0][3] + team_score[1][3]) == overtime_rounds)		//-- Go 2nd Overtime Half
            {
             ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_SCORE_CHANGED, 1)
             Core_GameChange()
             return //-- break
            }
          }
         case OVERTIME_HALF_SECOND:							//-- 2nd Overtime Half
          {
           if((team_score[0][3] + team_score[1][3]) == ((overtime_rounds * 2) - 1))//-- Begin Swap
            {
             Core_Transfer_Init()
            }
           else if((team_score[0][3] == (overtime_rounds + 1)) || (team_score[1][3] == (overtime_rounds + 1)) ||
                  ((team_score[0][3] == overtime_rounds) && (team_score[1][3] == overtime_rounds)))
            {
             ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_SCORE_CHANGED, 1)
             Core_GameChange()
             return //-- break
            }
          }
        }
       
       ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_SCORE_CHANGED, 0)
      }
    }
   //------------------------
  }
}
//----------------------------------------------------------------------------------
Core_Menu_StartSide_Show()
{
 if((assign_team != 0) && (assign_team != 1)) return
 //--
 new c_id = team_captain[team_side[assign_team]]
 if((c_id == 0) || (cs_get_user_team(c_id) != ((assign_team == 0) ? CS_TEAM_CT : CS_TEAM_T)))
  {
   new players[32], players_count
   get_players(players, players_count, "e", (assign_team == 0) ? "CT" : "TERRORIST")
   
   if(players_count > 0)
    {
     c_id = players[random(players_count)]
     team_captain[team_side[assign_team]] = c_id
    }
   else
    {
     team_side[assign_team] = 0
     return
    }
  }
 
 show_menu(c_id, MENU_KEY_1 | MENU_KEY_2, "\ySelect start side:^n^n\w 1. Terrorists^n\w 2. Counter-Terrorists")
}
//----------------------------------------------------------------------------------
//-----------------------------------[ TRANSFER ]-----------------------------------
//----------------------------------------------------------------------------------
Core_Transfer_TeamSort(const team_ct[], const team_ter[])
{
 new players[32], players_count
 new i
 
 get_players(players, players_count, "fgh", team_ct)
 for(i = 0; i < players_count; i++)
  {
   switch(cs_get_user_team(players[i]))
    {
     case CS_TEAM_T:
      {
       if(is_user_alive(players[i])) user_kill(players[i], 1)
       cs_set_user_team(players[i], CS_TEAM_CT, (get_pcvar_num(g_cw_transfer_model) != 0) ? transfer_model[0][random(3)]:CS_CT_URBAN)
      }
     case CS_TEAM_CT:
      {
       if(get_pcvar_num(g_cw_transfer_model) == 0)
        {
         cs_set_user_model(players[i], "urban")
        }
      }
    }
  }
 //--
 get_players(players, players_count, "fgh", team_ter)
 for(i = 0; i < players_count; i++)
  {
   switch(cs_get_user_team(players[i]))
    {
     case CS_TEAM_CT:
      {
       if(is_user_alive(players[i])) user_kill(players[i], 1)
       cs_set_user_team(players[i], CS_TEAM_T,  (get_pcvar_num(g_cw_transfer_model) != 0) ? transfer_model[1][random(3)]:CS_T_LEET)
      }
     case CS_TEAM_T:
      {
       if(get_pcvar_num(g_cw_transfer_model) == 0)
        {
         cs_set_user_model(players[i], "leet")
        }
      }
    }
  }
}
//----------------------------------------------------------------------------------
public Core_Transfer_TeamSwap()
{
 new i
 
 for(i = 0; i < transfer_count[0]; i++)
  {
   if(is_user_alive(transfer_players[0][i])) user_kill(transfer_players[0][i], 1)
   cs_set_user_team(transfer_players[0][i], CS_TEAM_T,  (get_pcvar_num(g_cw_transfer_model) != 0) ? transfer_model[1][random(3)]:CS_T_LEET)
  }
 
 for(i = 0; i < transfer_count[1]; i++)
  {
   if(is_user_alive(transfer_players[1][i])) user_kill(transfer_players[1][i], 1)
   cs_set_user_team(transfer_players[1][i], CS_TEAM_CT, (get_pcvar_num(g_cw_transfer_model) != 0) ? transfer_model[0][random(3)]:CS_CT_URBAN)
  }
 
 transfer_count = {0, 0}
 
 team_side[0]	= team_side[1]
 team_side[1]	= (team_side[0] == 0) ? 1:0
}
//----------------------------------------------------------------------------------
Core_Transfer_Init()
{
 get_players(transfer_players[0], transfer_count[0], "e", "CT")
 get_players(transfer_players[1], transfer_count[1], "e", "TERRORIST")
}
//----------------------------------------------------------------------------------
Core_Transfer_Do(bool:force=false)
{
 if(force)	Core_Transfer_TeamSwap()
 else		set_task(get_pcvar_float(g_cw_transfer_timeout), "Core_Transfer_TeamSwap")
}
//----------------------------------------------------------------------------------
//-------------------------------------[ MISC ]-------------------------------------
//----------------------------------------------------------------------------------
public Core_StripWeapons()
{
 new players[32], players_count
 new weapon_name[32], i
 
 get_weaponname(CSW_KNIFE, weapon_name, 31)
 
 get_players(players, players_count, "e", "CT")
 for(i = 0; i < players_count; i++)
  {
   strip_user_weapons(players[i])
   give_item(players[i], weapon_name)
  }
 
 get_players(players, players_count, "e",  "TERRORIST")
 for(i = 0;i < players_count; i++)
  {
   strip_user_weapons(players[i])
   give_item(players[i], weapon_name)
  }
 
 if(players_count > 0)
  {
   i = random(players_count)
   
   get_weaponname(CSW_C4, weapon_name, 31)
   give_item(players[i], weapon_name)
   cs_set_user_plant(players[i], 1, 1) 
  }
}
//----------------------------------------------------------------------------------
public Core_RestartRound(const time[])
{
 set_cvar_num("sv_restartround", str_to_num(time))
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
Core_Restart()
{
 new time_str[32], r_time[3][4], Float:r_time_f[3]
 new time_total, i
 
 get_pcvar_string(g_cw_restart, time_str, 31)
 
 time_total = 1
 parse(time_str, r_time[0], 3, r_time[1], 3, r_time[2], 3)
 
 for(i = 0; i < 3; i++)
  {
   if(!is_str_num(r_time[i])) formatex(r_time[i], 3, "1")
   time_total += str_to_num(r_time[i])
   r_time_f[i] = float(time_total)
  }
 
 r_time_f[0] = 0.1 //-- 0.01
 
 for(i = 0; i < 3; i++)
  {
   set_task(r_time_f[i], "Core_RestartRound", 0, r_time[i], strlen(r_time[i])) //-- + 1))
  }
}
//----------------------------------------------------------------------------------
//------------------------------------[ TASKs ]-------------------------------------
//----------------------------------------------------------------------------------
public Core_Task_TimeoutTimer()
{
 if(timeout_time > 0)
  {
   timeout_time--
  }
 else if(timeout_time == 0)
  {
   Core_GameChange()
   return PLUGIN_HANDLED
  }
  
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
public Core_Task_HalfBegin_Warmup()
{
 game_status		= GAME_HALF_WARMUP
 half_status		= HALF_INACTIVE
 half_number		= -1
 
 cw_exec_config("cw_round_warmup.cfg")
 ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_BEGIN, GAME_HALF_WARMUP)
 
 wait_restarts	= 0
 Core_RestartRound("1")
}
//----------------------------------------------------------------------------------
public Core_Task_HalfBegin_Knife()
{
 assign_team		= -1
 assign_swap		= -1
 
 game_status		= GAME_HALF_KNIFE
 half_status		= HALF_INACTIVE
 half_number		= 0
 
 cw_exec_config("cw_round_knife.cfg")
 ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_BEGIN, GAME_HALF_KNIFE)
 
 wait_restarts	= 2
 Core_Restart()
}
//----------------------------------------------------------------------------------
public Core_Task_HalfBegin_First()
{
 game_status		= GAME_HALF_FIRST
 half_status		= HALF_INACTIVE
 half_number		= 1
 
 cw_exec_config("cw_round_norm.cfg")
 ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_BEGIN, GAME_HALF_FIRST)
 
 wait_restarts	= 2
 Core_Restart()
}
//----------------------------------------------------------------------------------
public Core_Task_HalfBegin_Second()
{
 game_status		= GAME_HALF_SECOND
 half_status		= HALF_INACTIVE
 half_number		= 2
 
 cw_exec_config("cw_round_norm.cfg")
 ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_BEGIN, GAME_HALF_SECOND)
 
 wait_restarts	= 2
 Core_Restart()
}
//----------------------------------------------------------------------------------
public Core_Task_HalfBegin_Overtime()
{
 game_status		= GAME_HALF_OVERTIME
 half_status		= HALF_INACTIVE
 half_number		= 3
 
 cw_exec_config("cw_round_overtime.cfg")
 ExecuteForward(g_cw_EventGame, g_cw_EventReturn, CWE_GAME_HALF_BEGIN, GAME_HALF_OVERTIME)
 
 wait_restarts	= 2
 Core_Restart()
}
//----------------------------------------------------------------------------------
//----------------------------------[ HANDLERs ]------------------------------------
//----------------------------------------------------------------------------------
public Core_Handler_Menu_StartSide(id, key)
{
 if(assign_swap != -1) return PLUGIN_HANDLED
 //--
 new CsTeams:team_id = cs_get_user_team(id)
 
 if(((key == 0) && (team_id == CS_TEAM_CT)) || ((key == 1) && (team_id == CS_TEAM_T)))
  {
   assign_swap = 1
  }
 else
  {
   assign_swap = 0
  }
 
 Core_GameChange()
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
public Core_Handler_Event_NewRound()
{
 if((game_status == GAME_NULL) || (half_status != HALF_INACTIVE)) return
 //--
 if(wait_restarts > 0)
  {
   wait_restarts--
   return
  }
 
 set_task(0.5, "Core_HalfChange")
}
//----------------------------------------------------------------------------------
public Core_Handler_Event_ScoreCT()
{
 if(game_status != GAME_NULL)
  {
   Core_ScoreChange(team_side[0])
  }
}
//----------------------------------------------------------------------------------
public Core_Handler_Event_ScoreTer()
{
 if(game_status != GAME_NULL)
  {
   Core_ScoreChange(team_side[1])
  }
}
//----------------------------------------------------------------------------------
//-------------------------------------[ NATIVEs ]--------------------------------------
//----------------------------------------------------------------------------------
public Core_Native_Var_GetInteger()
{
 new var_id	= get_param(1)
 new arg	= get_param(2)
 
 switch(var_id)
  {
   case CWV_GAME_STATUS:
    {
     return game_status
    }
   case CWV_HALF_STATUS:
    {
     return half_status
    }
   case CWV_OVERTIME_STATUS:
    {
     return overtime_status
    }
   case CWV_HALF_NUMBER:
    {
     return half_number
    }
   case CWV_TEAM_CAPTAIN:
    {
     if	((arg == 0) || (arg == 1))	return team_captain[team_side[arg]]
     else if	((arg == 2) || (arg == 3))	return team_captain[arg - 2]
    }
   case CWV_TEAM_TSCORE:
    {
     if	((arg == 0) || (arg == 1))	return team_score[team_side[arg]][0]
     else if	((arg == 2) || (arg == 3))	return team_score[arg - 2][0]
    }
   case CWV_TEAM_HSCORE:
    {
     if	((arg == 0) || (arg == 1))	return team_score[team_side[arg]][half_number]
     else if	((arg == 2) || (arg == 3))	return team_score[arg - 2][half_number]
    }
   case CWV_TEAM_SIDE:
    {
     if	((arg == 0) || (arg == 1))	return team_side[arg]
    }
   case CWV_TIMEOUT_TIME:
    {
     return timeout_time
    }
  }
 
 return -1
}
//----------------------------------------------------------------------------------
public Core_Native_Var_GetString(var_id, out_str[], len, arg)
{
 param_convert(2)
 
 switch(var_id)
  {
   case CWV_GAME_STATUS:
    {
     num_to_str(game_status, out_str, len)
    }
   case CWV_HALF_STATUS:
    {
     num_to_str(half_status, out_str, len)
    }
   case CWV_OVERTIME_STATUS:
    {
     num_to_str(overtime_status, out_str, len)
    }
   case CWV_HALF_NUMBER:
    {
     num_to_str(half_number, out_str, len)
    }
   case CWV_TEAM_NAME:
    {
     if	((arg == 0) || (arg == 1))	formatex(out_str, len, "%s", team_name[team_side[arg]])
     else if	((arg == 2) || (arg == 3))	formatex(out_str, len, "%s", team_name[arg - 2])
     else					formatex(out_str, len, "")
    }
   case CWV_TEAM_CAPTAIN:
    {
     if	((arg == 0) || (arg == 1))	formatex(out_str, len, "%d", team_captain[team_side[arg]])
     else if	((arg == 2) || (arg == 3))	formatex(out_str, len, "%d", team_captain[arg - 2])
     else					formatex(out_str, len, "")
    }
   case CWV_TEAM_TSCORE:
    {
     if	((arg == 0) || (arg == 1))	num_to_str(team_score[team_side[arg]][0], out_str, len)
     else if	((arg == 2) || (arg == 3))	num_to_str(team_score[arg - 2][0], out_str, len)
     else					formatex(out_str, len, "")
    }
   case CWV_TEAM_HSCORE:
    {
     if	((arg == 0) || (arg == 1))	num_to_str(team_score[team_side[arg]][half_number], out_str, len)
     else if	((arg == 2) || (arg == 3))	num_to_str(team_score[arg - 2][half_number], out_str, len)
     else					formatex(out_str, len, "")
    }
   case CWV_TEAM_SIDE:
    {
     if	((arg == 0) || (arg == 1))	num_to_str(team_side[arg], out_str, len)
     else					formatex(out_str, len, "")
    }
   case CWV_TIMEOUT_TIME:
    {
     new m = 0, s = timeout_time
     
     if(s >= 60)
      {
       m  = s / 60
       s -= m * 60
       if(s >= 60) s = 59
      }
     
     formatex(out_str, len, (s > 9) ? "%d:%d" : "%d:0%d", m, s)
    }
  }
}
//----------------------------------------------------------------------------------
public Core_Native_Var_SetInteger()
{
 new var_id		= get_param(1)
 new var_value	= get_param(2)
 new arg		= get_param(3)
 
 switch(var_id)
  {
   case CWV_GAME_STATUS:
    {
     game_status	= var_value
    }
   case CWV_HALF_STATUS:
    {
     half_status	= var_value
    }
   case CWV_OVERTIME_STATUS:
    {
     overtime_status	= var_value
    }
   case CWV_HALF_NUMBER:
    {
     half_number	= var_value
    }
   case CWV_TEAM_CAPTAIN:
    {
     if	((arg == 0) || (arg == 1))	team_captain[team_side[arg]]			= var_value
     else if	((arg == 2) || (arg == 3))	team_captain[arg - 2]			= var_value
    }
   case CWV_TEAM_TSCORE:
    {
     if	((arg == 0) || (arg == 1))	team_score[team_side[arg]][0]		= var_value
     else if	((arg == 2) || (arg == 3))	team_score[arg - 2][0]			= var_value
    }
   case CWV_TEAM_HSCORE:
    {
     if	((arg == 0) || (arg == 1))	team_score[team_side[arg]][half_number]	= var_value
     else if	((arg == 2) || (arg == 3))	team_score[arg - 2][half_number]		= var_value
    }
   case CWV_TEAM_SIDE:
    {
     if	((arg == 0) || (arg == 1))	team_side[arg] = var_value
    }
   case CWV_TIMEOUT_TIME:
    {
     timeout_time	= var_value
    }
  }
}
//----------------------------------------------------------------------------------
public Core_Native_Var_SetString()
{
 new var_id	= get_param(1)
 new var_value[64]
 get_array(2, var_value, 63)
 new arg	= get_param(3)
 
 switch(var_id)
  {
   case CWV_GAME_STATUS:
    {
     game_status	= str_to_num(var_value)
    }
   case CWV_HALF_STATUS:
    {
     half_status	= str_to_num(var_value)
    }
   case CWV_OVERTIME_STATUS:
    {
     overtime_status	= str_to_num(var_value)
    }
   case CWV_HALF_NUMBER:
    {
     half_number	= str_to_num(var_value)
    }
   case CWV_TEAM_NAME:
    {
     if	((arg == 0) || (arg == 1))	formatex(team_name[team_side[arg]], 31, "%s", var_value)
     else if	((arg == 2) || (arg == 3))	formatex(team_name[arg - 2], 31, "%s", var_value)
    }
   case CWV_TEAM_CAPTAIN:
    {
     if	((arg == 0) || (arg == 1))	team_captain[team_side[arg]]			= str_to_num(var_value)
     else if	((arg == 2) || (arg == 3))	team_captain[arg - 2]			= str_to_num(var_value)
    }
   case CWV_TEAM_TSCORE:
    {
     if	((arg == 0) || (arg == 1))	team_score[team_side[arg]][0]		= str_to_num(var_value)
     else if	((arg == 2) || (arg == 3))	team_score[arg - 2][0]			= str_to_num(var_value)
    }
   case CWV_TEAM_HSCORE:
    {
     if	((arg == 0) || (arg == 1))	team_score[team_side[arg]][half_number]	= str_to_num(var_value)
     else if	((arg == 2) || (arg == 3))	team_score[arg - 2][half_number]		= str_to_num(var_value)
    }
   case CWV_TEAM_SIDE:
    {
     if	((arg == 0) || (arg == 1))	team_side[arg] = str_to_num(var_value)
    }
   case CWV_TIMEOUT_TIME:
    {
     timeout_time	= str_to_num(var_value)
    }
  }
}
//----------------------------------------------------------------------------------
public Core_Native_GameChange()
{
 Core_GameChange()
}
//----------------------------------------------------------------------------------
public Core_Native_ExecConfig()
{
 new cfg_name[128], cfg_dir[256]
 
 get_array(1, cfg_name, 127)
 get_pcvar_string(g_cw_conf_dir, cfg_dir, 255);
 
 server_cmd("exec ^"%s/%s^"", cfg_dir, cfg_name)
 server_exec()
}
//----------------------------------------------------------------------------------
public Core_Native_TrimFileName(file_name[], len)
{
 param_convert(1)
 
 replace_all(file_name, len, "/", "-")
 replace_all(file_name, len, "\", "-")
 replace_all(file_name, len, ":", "-")
 replace_all(file_name, len, "*", "-")
 replace_all(file_name, len, "?", "-")
 replace_all(file_name, len, ">", "-")
 replace_all(file_name, len, "<", "-")
 replace_all(file_name, len, "|", "-")
 replace_all(file_name, len, ".", "-")
}
//----------------------------------------------------------------------------------
public Core_Native_TrimUserName(user_name[], len, const team_tag[])
{
 param_convert(1)
 param_convert(3)
 
 if(get_pcvar_num(g_cw_clantag) != 0)
  {
   if(replace(user_name, len, team_tag, "") != 0) replace(user_name, len, "|", "")
  }
 
 trim(user_name)
}
//----------------------------------------------------------------------------------
public bool:Core_Native_GetTeamSide(CsTeams:team_id, &team_side)
{
 param_convert(2)
 
 switch(team_id)
  {
   case CS_TEAM_CT, CS_TEAM_T:
    {
     team_side = (team_id == CS_TEAM_CT) ? 0:1
     return true
    }
   default:
    {
     return false
    }
  }
 
 return false
}
//----------------------------------------------------------------------------------
//------------------------------[ PLUGIN INIT BEGIN ]-------------------------------
//----------------------------------------------------------------------------------
public plugin_natives()
{
 register_native("cw_var_get_int",		"Core_Native_Var_GetInteger")
 register_native("cw_var_get_str",		"Core_Native_Var_GetString",	1)
 register_native("cw_var_set_int",		"Core_Native_Var_SetInteger")
 register_native("cw_var_set_str",		"Core_Native_Var_SetString")
 
 register_native("cw_game_change",		"Core_Native_GameChange")
 
 register_native("cw_exec_config",		"Core_Native_ExecConfig")
 register_native("cw_trim_file_name",	"Core_Native_TrimFileName",	1)
 register_native("cw_trim_user_name",	"Core_Native_TrimUserName",	1)
 register_native("cw_get_team_side",	"Core_Native_GetTeamSide",	1)
}
//----------------------------------------------------------------------------------
public plugin_init()
{
 register_plugin("ClanWar XT [CORE]", CLAN_WAR_VERSION, CLAN_WAR_AUTHOR)
 
 g_cw_EventGame		= CreateMultiForward("cw_event_game",  ET_IGNORE, FP_CELL, FP_CELL)
 g_cw_EventError		= CreateMultiForward("cw_event_error", ET_IGNORE, FP_CELL, FP_CELL)
 
 register_event("HLTV",	"Core_Handler_Event_NewRound",	"a", "1=0", "2=0")
 register_event("SendAudio",	"Core_Handler_Event_ScoreCT",	"a", "2=%!MRAD_ctwin")
 register_event("SendAudio",	"Core_Handler_Event_ScoreTer",	"a", "2=%!MRAD_terwin")
  
 register_concmd("cw_start",		"Core_GameBegin",		ADMIN_LEVEL_A)
 register_concmd("cw_force",		"Core_GameForce",		ADMIN_LEVEL_A)
 register_concmd("cw_restart_game",	"Core_GameRestart",		ADMIN_LEVEL_A)
 register_concmd("cw_restart_half",	"Core_GameRestartHalf",	ADMIN_LEVEL_A)
 register_concmd("cw_abort",		"Core_GameAbort",		ADMIN_LEVEL_A)
 
 register_menucmd(register_menuid("\ySelect start side:"), 1023, "Core_Handler_Menu_StartSide")
 
 register_cvar("cw_mod", "<ClanWar XT>")
 g_cw_conf_dir		= register_cvar("cw_conf_dir",		"addons/clanwar")
 g_cw_clantag			= register_cvar("cw_clantag",		"0")
 g_cw_half_rounds		= register_cvar("cw_half_rounds",		"15")
 g_cw_half_timeout		= register_cvar("cw_half_timeout",		"1.5")
 g_cw_assign_mode		= register_cvar("cw_assign_mode",		"1") //-- 0 - 1st Team - CT, 2nd - T  1 - Knife Round
 g_cw_warmup_limit		= register_cvar("cw_warmup_limit",		"5.0")
 g_cw_overtime		= register_cvar("cw_overtime",		"1")
 g_cw_overtime_rounds	= register_cvar("cw_overtime_rounds",	"3")
 g_cw_overtime_timeout	= register_cvar("cw_overtime_timeout",	"3.0")
 g_cw_team_sort		= register_cvar("cw_team_sort",		"1")
 g_cw_transfer_model		= register_cvar("cw_transfer_model",	"0")
 g_cw_transfer_timeout	= register_cvar("cw_transfer_timeout",	"3.0")
 g_cw_restart			= register_cvar("cw_restart",		"1 2 3")
 
 game_status			= GAME_NULL
 half_status			= HALF_NULL
 overtime_status		= OVERTIME_NULL
 
 transfer_model[0][0]	= CS_CT_URBAN
 transfer_model[0][1]	= CS_CT_GSG9
 transfer_model[0][2]	= CS_CT_GIGN
 transfer_model[0][3]	= CS_CT_SAS
 
 transfer_model[1][0]	= CS_T_TERROR
 transfer_model[1][1]	= CS_T_LEET
 transfer_model[1][2]	= CS_T_ARCTIC
 transfer_model[1][3]	= CS_T_GUERILLA
}
//----------------------------------------------------------------------------------
public plugin_end()
{
 DestroyForward(g_cw_EventGame)
}
//-------------------------------[ PLUGIN INIT END ]--------------------------------
//----------------------------------------------------------------------------------
