#include <amxmodx>
#include "include/clanwar_const"
#include "include/clanwar_core"


//----------------------------------------------------------------------------------
CVAR_Range_Int(const var_name[], val_min, val_max)
{
 new cvar_value = get_cvar_num(var_name)
 if(cvar_value < val_min)		set_cvar_num(var_name, val_min)
 else if(cvar_value > val_max)	set_cvar_num(var_name, val_max)
}
//----------------------------------------------------------------------------------
CVAR_Range_Float(const var_name[], Float:val_min, Float:val_max)
{
 new Float:cvar_value = get_cvar_float(var_name)
 if(cvar_value < val_min)		set_cvar_float(var_name, val_min)
 else if(cvar_value > val_max)	set_cvar_float(var_name, val_max);
}
//----------------------------------------------------------------------------------
CVAR_Check()
{
 CVAR_Range_Int  ("cw_clantag",			0, 1)
 CVAR_Range_Int  ("cw_team_sort",			0, 1)
 CVAR_Range_Float("cw_warmup_limit",		0.0, 60.0)
 CVAR_Range_Int  ("cw_assign_mode",		0, 1)
 CVAR_Range_Int  ("cw_overtime",			0, 1)
 CVAR_Range_Int  ("cw_half_rounds",		3, 100)
 CVAR_Range_Float("cw_half_timeout",		0.1, 60.0)
 CVAR_Range_Int  ("cw_overtime_rounds",		2, 30)
 CVAR_Range_Float("cw_overtime_timeout",		0.1, 60.0)
 
 CVAR_Range_Int  ("cw_transfer_model",		0, 1)
 CVAR_Range_Float("cw_transfer_timeout",		0.01, 5.0)
  
 CVAR_Range_Int  ("cw_ready_timeout",		0, 1)
 CVAR_Range_Int  ("cw_ready_min",			1, 16)
 CVAR_Range_Int  ("cw_pov_record",			0, 2)
 CVAR_Range_Int  ("cw_hltv_record",		0, 1) 
 CVAR_Range_Float("cw_hltv_disconnect_delay",	0.01, 540.0)
 
 CVAR_Range_Int  ("cw_score_show",			0, 1)
 CVAR_Range_Float("cw_score_timeout",		0.01, 10.0)
 
 CVAR_Range_Int  ("cw_cvar_force_block",		0, 1)
}
//----------------------------------------------------------------------------------
public cw_event_game(msg, arg)
{
 if((msg == CWE_GAME_INIT) || (msg == CWE_GAME_RESTART))
  {
   CVAR_Check()
  }
 
 return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------
//------------------------------[ PLUGIN INIT BEGIN ]-------------------------------
public plugin_init()
{
 register_plugin("ClanWar XT [CVAR]", CLAN_WAR_VERSION, CLAN_WAR_AUTHOR)
}
//-------------------------------[ PLUGIN INIT END ]--------------------------------
//----------------------------------------------------------------------------------
