#include <amxmodx>
#include "include/clanwar_const"
#include "include/clanwar_core"

enum CvarRules {
       CVAR_NULL      = 0,
       CVAR_EQUALS    = 1,
       CVAR_OTHERTHEN = 2,
       CVAR_BIGER     = 3,
       CVAR_SMALLER   = 4
};

new force_cvar[256][32], Float:force_param[256][2], CvarRules:force_rule[256]
new force_count

//----------------------------------------------------------------------------------
CvarRules:Force_GetCvarRule(cvar_param[])
{
 if     (cvar_param[0] == '=') return CVAR_EQUALS
 else if(cvar_param[0] == '!') return CVAR_OTHERTHEN
 else if(cvar_param[0] == '>') return CVAR_BIGER
 else if(cvar_param[0] == '<') return CVAR_SMALLER
 
 return CVAR_NULL
}
//----------------------------------------------------------------------------------
bool:Force_CheckCvarAgRule(Float:cvar_value, Float:cvar_value_bad, CvarRules:cvar_rule)
{
 if(cvar_rule == CVAR_EQUALS)
  {
   if(cvar_value == cvar_value_bad)	return true
   else					return false
  }
 else if(cvar_rule == CVAR_OTHERTHEN)
  {
   if(cvar_value != cvar_value_bad)	return true
   else					return false
  }
 else if(cvar_rule == CVAR_BIGER)
  {
   if(cvar_value > cvar_value_bad)		return true
   else					return false
  }
 else if(cvar_rule == CVAR_SMALLER)
  {
   if(cvar_value < cvar_value_bad)		return true
   else					return false
  }
 
 return false
}
//----------------------------------------------------------------------------------
public Force_AddCvar(id)
{
 if(force_count >= 256) return PLUGIN_HANDLED
 //--
 new argv[128]
 new cvar_name[32], cvar_param[2][8], CvarRules:cvar_rule
 
 read_args(argv, 127)
 parse    (argv, cvar_name, 31, cvar_param[0], 7, cvar_param[1], 7)
 
 trim(cvar_name)
 trim(cvar_param[0])
 trim(cvar_param[1])
 
 if(strlen(cvar_name) == 0 || strlen(cvar_param[0]) == 0 || strlen(cvar_param[1]) == 0)
  {/*
   server_print("+----------[FORCED CVARS]----------+")
   for(new i = 0; i < force_count; i++)
   	{
     server_print("%s		%f	%f", force_cvar[i], force_param[i][0], force_param[i][1])
    }
   server_print("+----------------------------------+")
   */
   return PLUGIN_HANDLED
  }
 
 cvar_rule = Force_GetCvarRule(cvar_param[0])
 if(cvar_rule == CVAR_NULL) return PLUGIN_CONTINUE
 
 copy(force_cvar[force_count], 31, cvar_name)
 force_param[force_count][0]	= floatstr(cvar_param[0][1])
 force_param[force_count][1]	= floatstr(cvar_param[1])
 force_rule [force_count]	= cvar_rule
 force_count++
 
 Force_UpdateAll()
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
Force_SetClientCvars(id)
{
 if(is_user_hltv(id)) return
 //--
 for(new i = 0; i < force_count; i++)
  {
   query_client_cvar(id, force_cvar[i], "Force_Handler_QueryResult");
  }
}
//----------------------------------------------------------------------------------
Force_UpdateAll()
{
 new players[32], players_count
 
 get_players(players, players_count, "ch")
 if(players_count > 0)
  {
   for(new i = 0; i < players_count; i++)
    {
     Force_SetClientCvars(players[i])
    }
  }
}
//----------------------------------------------------------------------------------
public Force_Handler_QueryResult(id, const cvar[], const value[])
{
 new Float:cvar_value = floatstr(value)
 
 for(new i = 0; i < force_count; i++)
  {
   if(equali(force_cvar[i], cvar) != 0)
    {
     if(Force_CheckCvarAgRule(cvar_value, force_param[i][0], force_rule[i]))
      {
       client_cmd(id, "%s %f", force_cvar[i], force_param[i][1])
       if(get_cvar_num("cw_cvar_force_block") != 0) client_cmd(id, "alias %s", force_cvar[i])
      }
     
     break
    }
  }
}
//----------------------------------------------------------------------------------
public client_connect(id)
{
 if(!is_user_hltv(id) && !is_user_bot(id)) Force_SetClientCvars(id)
 return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------
//------------------------------[ PLUGIN INIT BEGIN ]-------------------------------
public plugin_init()
{
 register_plugin("ClanWar XT [FORCE]", CLAN_WAR_VERSION, CLAN_WAR_AUTHOR)
 
 register_srvcmd("cw_cvar_force",		"Force_AddCvar")
 register_cvar  ("cw_cvar_force_block",	"0")
 
 force_count = 0
 
 cw_exec_config("cw_force.cfg")
}
//-------------------------------[ PLUGIN INIT END ]--------------------------------
//----------------------------------------------------------------------------------
