#include <amxmodx>
#include <cstrike>
#include <sockets>
#include "include/clanwar_const"
#include "include/clanwar_core"

new g_cw_pov_record, g_cw_pov_demo_format 
new g_cw_hltv_record, g_cw_hltv_demo_format, g_cw_hltv_ip, g_cw_hltv_port, g_cw_hltv_rcon, g_cw_hltv_disconnect_delay, g_cw_hltv_demo_folder

new hltv_cvar[32][32], hltv_cvar_param[32][64], hltv_cvar_count

new sock_hltv, hltv_rcon_id[13]
new pov_players[32], pov_count

//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
public HLTV_AddCvar(id)
{
 if(hltv_cvar_count >= 32) return PLUGIN_HANDLED
 //--
 new argv[128]
 new cvar_name[32], cvar_param[64]
 
 read_args(argv, 127)
 parse    (argv, cvar_name, 31, cvar_param, 63)
 
 if(strlen(cvar_name) == 0) return PLUGIN_HANDLED
 
 copy(hltv_cvar[hltv_cvar_count], 31, cvar_name)
 copy(hltv_cvar_param[hltv_cvar_count],	63, cvar_param)
 hltv_cvar_count++
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
HLTV_ForceCvar()
{
 new cmd[128]
 
 for(new i = 0; i < hltv_cvar_count; i++)
  {
   formatex(cmd, 127, "%s ^"%s^"", hltv_cvar[i], hltv_cvar_param[i])
   HLTV_ExecCmd(cmd)
  }
}
//----------------------------------------------------------------------------------
//-------------------------------------[ HLTV ]-------------------------------------
//----------------------------------------------------------------------------------
bool:HLTV_Connect()
{
 if(sock_hltv > 0) HLTV_Close()
 //--
 new hltv_ip[16], hltv_port, hltv_rcon[32]
 new error = 0
 
 get_pcvar_string(g_cw_hltv_ip,   hltv_ip,   15)
 get_pcvar_string(g_cw_hltv_rcon, hltv_rcon, 31)
 hltv_port = get_pcvar_num(g_cw_hltv_port)
 
 if((strlen(hltv_ip) == 0) || (strlen(hltv_rcon) == 0) || (hltv_port <= 0)) return false
 
 sock_hltv = socket_open(hltv_ip, hltv_port, SOCKET_UDP, error)
 if(error != 0) return false
 
 if(!HLTV_Challenge())
  {
   HLTV_Close()
   return false
  }
 
 return true
}
//----------------------------------------------------------------------------------
HLTV_Close()
{
 socket_close(sock_hltv)
 sock_hltv = -1
}
//----------------------------------------------------------------------------------
bool:HLTV_Challenge()
{
 for(new i = 0; i <= 3; i++)
  {
   new rcv[256], snd[256]
   
   setc(snd, 4, 0xFF)
   copy(snd[4], 255, "challenge rcon")
   setc(snd[18], 1, '^n')
   
   socket_send(sock_hltv, snd, 255)
   socket_recv(sock_hltv, rcv, 255)
   
   copy   (hltv_rcon_id, 12, rcv[19])
   replace(hltv_rcon_id, 12, "^n", "")
   
   if(strlen(hltv_rcon_id) != 0) return true
  }
 
 return false
}
//----------------------------------------------------------------------------------
HLTV_Disconnect()
{
 if(get_pcvar_num(g_cw_hltv_record) ==  0) return
 //--
 if(!task_exists(TASK_HLTV_DISCONNECT)) set_task(get_pcvar_float(g_cw_hltv_disconnect_delay), "HLTV_DelayDisconnect", TASK_HLTV_DISCONNECT)
}
//----------------------------------------------------------------------------------
public HLTV_DelayDisconnect()
{
 if(!HLTV_Connect()) return PLUGIN_CONTINUE
 //--
 new cmd[64]
 
 formatex(cmd, 63, "stop")
 HLTV_ExecCmd(cmd)
 
 formatex(cmd, 63, "autoretry 0")
 HLTV_ExecCmd(cmd)
 
 formatex(cmd, 63, "disconnect")
 HLTV_ExecCmd(cmd)
 
 HLTV_Close()
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
bool:HLTV_ExecCmd(cmd[])
{
 if(sock_hltv <= 0) return false
 //--
 new snd[256], hltv_rcon[32]
 
 get_pcvar_string(g_cw_hltv_rcon, hltv_rcon, 31)
 
 setc(snd, 255, 0x00)
 setc(snd, 4, 0xFF)
 formatex(snd[4], 255, "rcon %s ^"%s^" %s^n", hltv_rcon_id, hltv_rcon, cmd)
 socket_send(sock_hltv, snd, 255)
 
 return true
}
//----------------------------------------------------------------------------------
bool:HLTV_Find()
{
 new players[32], players_count
 new hltv_cvar_ip[16], hltv_cvar_port
 new hltv_cvar_address[32], hltv_client_address[32]
 
 get_pcvar_string(g_cw_hltv_ip,   hltv_cvar_ip,   15)
 hltv_cvar_port = get_pcvar_num(g_cw_hltv_port)
 formatex(hltv_cvar_address, 31, "%s:%d", hltv_cvar_ip, hltv_cvar_port)
 
 get_players(players, players_count, "b")
 
 for(new i = 0; i < players_count; i++)
  {
   if(is_user_hltv(players[i]))
    {
     get_user_ip(players[i], hltv_client_address, 31, 0)
     if(equal(hltv_cvar_address, hltv_client_address) != 0) return true
    }
  }
 
 return false
}
//----------------------------------------------------------------------------------
HLTV_Invite()
{
 if(!HLTV_Connect()) return
 //--
 new cmd[64]
 new server_pass[32], server_ip[16], server_port
 
 get_cvar_string("sv_password", server_pass, 31)
 formatex(cmd, 63, "serverpassword ^"%s^"", server_pass)
 HLTV_ExecCmd(cmd)
 
 formatex(cmd, 63, "autoretry 1")
 HLTV_ExecCmd(cmd)
 
 HLTV_ForceCvar()
 
 get_cvar_string("ip", server_ip, 15)
 server_port = get_cvar_num("port")
 formatex(cmd, 63, "connect %s:%d", server_ip, server_port)
 HLTV_ExecCmd(cmd)
 
 HLTV_Close()
}
//----------------------------------------------------------------------------------
HLTV_Record()
{
 if(get_pcvar_num(g_cw_hltv_record) ==  0) return
 //--
 new file_name[256]
 new server_map[32], server_date[32]
 new team_name[2][32]
 
 get_mapname(server_map, 31) 
 get_time("%Y%m%d_%H%M", server_date, 31)
 
 cw_var_get_str(CWV_TEAM_NAME, team_name[0], 31, 0)
 cw_var_get_str(CWV_TEAM_NAME, team_name[1], 31, 1)
 
 get_pcvar_string(g_cw_hltv_demo_format, file_name, 255)
 
 replace_all(file_name, 255, "[TEAM1]",	team_name[0]);
 replace_all(file_name, 255, "[TEAM2]",	team_name[1]);
 replace_all(file_name, 255, "[MAP]",	server_map);
 replace_all(file_name, 255, "[DATE]",	server_date);
 
 cw_trim_file_name(file_name, 255)
 
 if(!HLTV_Find())	HLTV_Invite()
 if(!HLTV_Connect())	return
 //--
 new cmd[64]
 
 get_pcvar_string(g_cw_hltv_demo_folder, cmd, 63)
 if(!dir_exists(cmd)) mkdir(cmd)
 
 format(cmd, 63, "record ^"%s/%s^"", cmd, file_name)
 HLTV_ExecCmd(cmd)
 HLTV_Close()
}
//----------------------------------------------------------------------------------
//--------------------------------[ POV RECORDING ]---------------------------------
//----------------------------------------------------------------------------------
POV_ClientRecord_Start(id)
{
 if(get_pcvar_num(g_cw_pov_record) == 1)
  {
   POV_RecordMenu_Show(id)
  }
 else if(get_pcvar_num(g_cw_pov_record) == 2)
  {
   pov_players[pov_count] = id
   pov_count++
  }
}
//----------------------------------------------------------------------------------
POV_ClientRecord_Restart(game_progress)
{
 if(get_pcvar_num(g_cw_pov_record) == 0)  return
 //--
 new file_name[256]
 new server_map[32], server_date[32]
 new player_name[32], team_name[2][32], CsTeams:team_id, team_side
 new game_half[8]

 get_mapname(server_map, 31) 
 get_time("%Y%m%d_%H%M", server_date, 31)

 cw_var_get_str(CWV_TEAM_NAME, team_name[0], 31, 0)
 cw_var_get_str(CWV_TEAM_NAME, team_name[1], 31, 1)

 switch(game_progress)
  {
    case GAME_HALF_KNIFE:
     {
      formatex(game_half, 7, "KNF")
     }
    case GAME_HALF_FIRST:
     {
      formatex(game_half, 7, "1ST")
     }
    case GAME_HALF_SECOND:
     {
      formatex(game_half, 7, "2ND")
     }
    case GAME_HALF_OVERTIME:
     {
      formatex(game_half, 7, "OVT")
     }
    default:
     {
      formatex(game_half, 7, "%d", game_progress)
     }
  }
 
 for(new i; i < pov_count; i++)
  {
   team_id = cs_get_user_team(pov_players[i])
   if(!cw_get_team_side(team_id, team_side)) continue
    
   get_user_name(pov_players[i], player_name, 31)
   cw_trim_user_name(player_name, 31, team_name[team_side])
   
   get_pcvar_string(g_cw_pov_demo_format, file_name, 255)
   
   replace_all(file_name, 255, "[TEAM1]",	team_name[0]);
   replace_all(file_name, 255, "[TEAM2]",	team_name[1]);
   replace_all(file_name, 255, "[MAP]",	server_map);
   replace_all(file_name, 255, "[DATE]",	server_date);
   replace_all(file_name, 255, "[NAME]",	player_name);
   replace_all(file_name, 255, "[HALF]",	game_half);
   
   cw_trim_file_name(file_name, 255)
   
   client_cmd(pov_players[i], "stop")
   client_cmd(pov_players[i], "record ^"%s^"", file_name)
  }
}
//----------------------------------------------------------------------------------
POV_Record()
{
 if(get_pcvar_num(g_cw_pov_record) ==  0) return
 //--
 new players[32], players_count
 new i
 
 pov_count = 0
 
 get_players(players, players_count, "ce", "CT")
 for(i = 0; i < players_count; i++)
  {
   POV_ClientRecord_Start(players[i])
  }
 
 get_players(players, players_count, "ce", "TERRORIST")
 for(i = 0; i < players_count; i++)
  {
   POV_ClientRecord_Start(players[i])
  }
}
//----------------------------------------------------------------------------------
public POV_Stop()
{
 if(get_pcvar_num(g_cw_pov_record) == 0)  return
 //--
 for(new i; i < pov_count; i++)
  {
   client_cmd(pov_players[i], "stop")
  }
}
//----------------------------------------------------------------------------------
POV_RecordMenu_Show(id)
{
 show_menu(id, MENU_KEY_1 | MENU_KEY_2, "\yRecord Demo^n\dDo you wish to record a demo (POV):^n^n\w1. Yes^n2. No")
}
//----------------------------------------------------------------------------------
public POV_RecordMenu_Handler(id, key)
{
 if(key == 0)
  {
   pov_players[pov_count] = id
   pov_count++
  }
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
public cw_event_game(msg, arg)
{
 switch(msg)
  {
   case CWE_GAME_HALF_STARTED:
    {
     if(arg == GAME_HALF_WARMUP)
      {
       HLTV_Invite()
       POV_Record()
      }
    }
   case CWE_GAME_HALF_END:
    {
     if(arg  == GAME_HALF_WARMUP)
      {
       HLTV_Record()
      }
     else
      {
       set_task(1.0, "POV_Stop")
      }
    }
   case CWE_GAME_HALF_BEGIN:
    {
     if(arg != GAME_HALF_WARMUP)
      {
       POV_ClientRecord_Restart(arg)
      }
    }
   case CWE_GAME_END:
    {
     HLTV_Disconnect()
     POV_Stop()
     pov_count = 0
    }
   case CWE_GAME_RESTART, CWE_GAME_ABORT:
    {
     HLTV_DelayDisconnect()
     POV_Stop()
     pov_count = 0
    }
  }
 
 return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------
//------------------------------[ PLUGIN INIT BEGIN ]-------------------------------
public plugin_init()
{
 register_plugin("ClanWar XT [HLTV]", CLAN_WAR_VERSION, CLAN_WAR_AUTHOR)
 
 register_srvcmd ("cw_cvar_hltv", "HLTV_AddCvar")
 register_menucmd(register_menuid("\yRecord Demo"), 1023, "POV_RecordMenu_Handler")
 
 g_cw_pov_record		= register_cvar("cw_pov_record",			"0") //-- 0 - No  1 - Ask  2 - Force
 g_cw_pov_demo_format	= register_cvar("cw_pov_demo_format",		"[TEAM1]_vs_[TEAM2]-[MAP]_[DATE]-[NAME]-POV([HALF])")
 g_cw_hltv_record		= register_cvar("cw_hltv_record",			"0") //-- 0 - No  1 - Yes
 g_cw_hltv_demo_format	= register_cvar("cw_hltv_demo_format",		"[TEAM1]_vs_[TEAM2]-[MAP]_[DATE]-HLTV")
 g_cw_hltv_ip			= register_cvar("cw_hltv_ip",			"127.0.0.1")
 g_cw_hltv_port		= register_cvar("cw_hltv_port",			"27020")
 g_cw_hltv_rcon		= register_cvar("cw_hltv_rcon",			"")
 g_cw_hltv_disconnect_delay	= register_cvar("cw_hltv_disconnect_delay",	"10")
 g_cw_hltv_demo_folder	= register_cvar("cw_hltv_demo_folder",		"demos")
 
 sock_hltv		= -1
 pov_count		= 0
 hltv_cvar_count	= 0
 
 cw_exec_config("cw_hltv.cfg")
}
//----------------------------------------------------------------------------------
public plugin_end()
{
 HLTV_Close()
}
//-------------------------------[ PLUGIN INIT END ]--------------------------------
//----------------------------------------------------------------------------------
