#include <amxmodx>
#include <cstrike>
#include "include/clanwar_const"
#include "include/clanwar_core"

new g_cw_score_show, g_cw_score_timeout

new msg_var[128][64], msg_text[128][256], msg_index
new tc_var[64]
new win_team

//----------------------------------------------------------------------------------
//--------------------------------[ MESSAGE SYSTEM ]--------------------------------
//----------------------------------------------------------------------------------
bool:Message_Load()
{
 new file_name[128]
 get_cvar_string("cw_conf_dir", file_name, 127);
 format(file_name, 127, "%s/cw_messages.ini", file_name)
 
 if(!file_exists(file_name)) return false
 //--
 new read_buf[1024], read_pos, read_len
 new i
 
 msg_index	= 0
 read_pos	= 0
 while(read_file(file_name, read_pos++, read_buf, 1023, read_len) && (msg_index < 128))
  {
   if((read_len <= 0) || (read_buf[0] == ';')) continue
   
   i = contain(read_buf, "=")
   if(i <= 5) continue
   
   copyc(msg_var[msg_index], 63, read_buf, '=')
   trim (msg_var[msg_index])
   
   formatex(msg_text[msg_index], 255, "%s", read_buf[i+1])
   msg_index++
  }
 
 return true
}
//----------------------------------------------------------------------------------
Message_ParseVars(text[], len, id = 0, team_side = -2)
{
 new tmp32[32]
 
 replace_all(text, len, "[BR]", "^n")
 
 if(contain(text, "[MOD]")			!= -1)	{ get_cvar_string("cw_mod", tmp32, 31); replace_all(text, len, "[MOD]", tmp32); }
 if(contain(text, "[TEAM_CT]")		!= -1)	{ cw_var_get_str(CWV_TEAM_NAME, tmp32, 31, 0); replace_all(text, len, "[TEAM_CT]",	tmp32); }
 if(contain(text, "[TEAM_TER]")		!= -1)	{ cw_var_get_str(CWV_TEAM_NAME, tmp32, 31, 1); replace_all(text, len, "[TEAM_TER]",	tmp32); }
 if(contain(text, "[TEAM_1]")		!= -1)	{ cw_var_get_str(CWV_TEAM_NAME, tmp32, 31, 2); replace_all(text, len, "[TEAM_1]",	tmp32); }
 if(contain(text, "[TEAM_2]")		!= -1)	{ cw_var_get_str(CWV_TEAM_NAME, tmp32, 31, 3); replace_all(text, len, "[TEAM_2]",	tmp32); }
 if(contain(text, "[TEAM_TSCORE_CT]")	!= -1) { cw_var_get_str(CWV_TEAM_TSCORE, tmp32, 31, 0); replace_all(text, len, "[TEAM_TSCORE_1]", tmp32); }
 if(contain(text, "[TEAM_TSCORE_TER]")	!= -1) { cw_var_get_str(CWV_TEAM_TSCORE, tmp32, 31, 1); replace_all(text, len, "[TEAM_TSCORE_2]", tmp32); }
 if(contain(text, "[TEAM_TSCORE_1]")	!= -1) { cw_var_get_str(CWV_TEAM_TSCORE, tmp32, 31, 2); replace_all(text, len, "[TEAM_TSCORE_1]", tmp32); }
 if(contain(text, "[TEAM_TSCORE_2]")	!= -1) { cw_var_get_str(CWV_TEAM_TSCORE, tmp32, 31, 3); replace_all(text, len, "[TEAM_TSCORE_2]", tmp32); }
 if(contain(text, "[TEAM_HSCORE_CT]")	!= -1) { cw_var_get_str(CWV_TEAM_HSCORE, tmp32, 31, 0); replace_all(text, len, "[TEAM_HSCORE_1]", tmp32); }
 if(contain(text, "[TEAM_HSCORE_TER]")	!= -1) { cw_var_get_str(CWV_TEAM_HSCORE, tmp32, 31, 1); replace_all(text, len, "[TEAM_HSCORE_2]", tmp32); }
 if(contain(text, "[TEAM_HSCORE_1]")	!= -1) { cw_var_get_str(CWV_TEAM_HSCORE, tmp32, 31, 2); replace_all(text, len, "[TEAM_HSCORE_1]", tmp32); }
 if(contain(text, "[TEAM_HSCORE_2]")	!= -1) { cw_var_get_str(CWV_TEAM_HSCORE, tmp32, 31, 3); replace_all(text, len, "[TEAM_HSCORE_2]", tmp32); }
 if(contain(text, "[TEAM_WIN]") 		!= -1)	{ cw_var_get_str(CWV_TEAM_NAME, tmp32, 31, win_team); replace_all(text, len, "[TEAM_WIN]", tmp32); }
 if(contain(text, "[TEAM_LOSE]") 		!= -1)	{ cw_var_get_str(CWV_TEAM_NAME, tmp32, 31, (win_team == 0) ? 1:0); replace_all(text, len, "[TEAM_LOSE]", tmp32); }
 if(contain(text, "[COUNTDOWN]")		!= -1) { cw_var_get_str(CWV_TIMEOUT_TIME, tmp32, 31, 0); replace_all(text, len, "[COUNTDOWN]", tmp32); }
 if(contain(text, "[MAP]")			!= -1)	{ get_mapname(tmp32, 31);  replace_all(text, len, "[MAP]", tmp32); }
 
 //--
 if((id != 0) && (contain(text, "[PNAME]") != -1))
  {
   new t_name[32], t_side = team_side
   if(t_side == -1) cw_get_team_side(cs_get_user_team(id), t_side)
   
   get_user_name(id, tmp32, 31)
   cw_var_get_str(CWV_TEAM_NAME, t_name, 31, t_side)
   cw_trim_user_name(tmp32, 31, t_name)
   
   replace_all(text, len, "[PNAME]", tmp32)
  }
 
 if((team_side != -2) && (contain(text, "[PTEAM]") != -1))
  {
   new t_side = team_side
   if((t_side == -1) && (id != 0)) cw_get_team_side(cs_get_user_team(id), t_side)
   
   if(get_cvar_num("cw_clantag") != 0)	cw_var_get_str(CWV_TEAM_NAME, tmp32, 31, t_side)
   else					formatex(tmp32, 31, "%s", (t_side == 0) ? "Counter-Terrorists":"Terrorists")
   
   replace_all(text, len, "[PTEAM]", tmp32)
  }
}
//----------------------------------------------------------------------------------
Message_ParseHud(const var_name[], out_str[], len, &r, &g, &b, &Float:x, &Float:y, &effect)
{
 new tmp[10]
 new c, j
 
 for(new i = 0; i < msg_index; i++)
  {
   if(containi(msg_var[i], var_name) != -1)
    {
     j = contain(msg_var[i], "[")
     if(j <= 1) break
     j++
     
     formatex(out_str, len, "%s", msg_text[i])
     
     c  = copyc(tmp, 9, msg_var[i][j++], ',')
     r  = str_to_num(tmp)
     j += c
     
     c  = copyc(tmp, 9, msg_var[i][j++], ',')
     g  = str_to_num(tmp)
     j += c
     
     c  = copyc(tmp, 9, msg_var[i][j++], ',')
     b  = str_to_num(tmp)
     j += c
     
     c  = copyc(tmp, 9, msg_var[i][j++], ',')
     x  = str_to_float(tmp)
     j += c
     
     c  = copyc(tmp, 9, msg_var[i][j++], ',')
     y  = str_to_float(tmp)
     j += c
     
     c  = copyc(tmp, 9, msg_var[i][j++], ',')
     effect = str_to_num(tmp)
     j += c
     
     c  = copyc(tmp, 9, msg_var[i][j++], ']')
     return str_to_num(tmp)
    }
  }
 
 return -1
}
//----------------------------------------------------------------------------------
Message_ParseClient(const var_name[], out_str[], len, &type)
{
 new tmp[10]
 new c, j
 
 for(new i = 0; i < msg_index; i++)
  {
   if(containi(msg_var[i], var_name) != -1)
    {
     j  = contain(msg_var[i], "(")
     if(j <= 1) break
     j++
     
     formatex(out_str, len, "%s", msg_text[i])
     
     c    = copyc(tmp, 9, msg_var[i][j++], ',')
     type = str_to_num(tmp)
     j   += c
     
     c    = copyc(tmp, 9, msg_var[i][j++], ')')
     return str_to_num(tmp)
    }
  }
  
 return -1
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
Message_THud(id, const text[], r, g, b, Float:x, Float:y, effect, Float:t, channel=-1)
{
 set_hudmessage (r, g, b, x, y, effect, 6.0, t, 0.2, 0.2, channel)
 show_hudmessage(id, text)
}
//----------------------------------------------------------------------------------
Message_VHud(id, const var_name[], channel=-1, player_id = 0, team_side = -2)
{
 new text[256]
 new r, g, b, effect
 new Float:x, Float:y
 new t = Message_ParseHud(var_name, text, 255, r, g, b, x, y, effect)
 if (t > 0)
  {
   Message_ParseVars(text, 255, player_id, team_side)
   Message_THud(id, text, r, g, b, x, y, effect, float(t), channel)
  }
}
//----------------------------------------------------------------------------------
Message_TClient(id, const text[], type, count)
{
 new print_mode
 switch(type)
  {
   case 1:  print_mode = print_chat
   case 2:  print_mode = print_console
   case 3:  print_mode = print_center
   default: print_mode = print_chat
  }
 
 for(new i = 0; i < count; i++) client_print(id, print_mode, text)
}
//----------------------------------------------------------------------------------
Message_VClient(id, const var_name[], player_id = 0, team_side = -2)
{
 new text[256], type
 new count = Message_ParseClient(var_name, text, 255, type)
 if (count > 0)
  {
   Message_ParseVars(text, 255, player_id, team_side)
   Message_TClient  (id, text, type, count)
  }
}
//----------------------------------------------------------------------------------
Message_TServer(const text[], count)
{
 for(new i = 0; i < count; i++) server_print(text)
}
//----------------------------------------------------------------------------------
Message_VServer(const var_name[], player_id = 0, team_side = -2)
{
 new text[256], type
 new count = Message_ParseClient(var_name, text, 255, type)
 if (count > 0)
  {
   Message_ParseVars(text, 255, player_id, team_side)
   Message_TServer  (text, count)
  }
}
//----------------------------------------------------------------------------------
//-----------------------------------[ HANDLERs ]-----------------------------------
//----------------------------------------------------------------------------------
public Message_ShowScore(id)
{
 if(cw_var_get_int(CWV_GAME_STATUS) != GAME_NULL)
  {
   Message_VClient(id, "cm_score_info")
  }
 
 return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------
//------------------------------------[ TASKs ]-------------------------------------
//----------------------------------------------------------------------------------
public Message_Task_WarmupInfo()
{
 Message_VClient(0, "cm_warmup_info_cmd")
 Message_VClient(0, "cm_warmup_info_knife")
 Message_VClient(0, "cm_warmup_info_ready")
}
//----------------------------------------------------------------------------------
public Message_Task_ScoreInfo()
{
 Message_VHud   (0, "hud_score_info", CHANNEL_TC)
 Message_VClient(0, "cm_score_info")
}
//----------------------------------------------------------------------------------
public Message_Task_TC()
{
 Message_VHud(0, tc_var, CHANNEL_TC)
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
public Message_TCHud_Show(const var_name[])
{
 new tc_msg[10], tc_color[3], Float:tc_pos[2], tc_effect 
 new tc_time = Message_ParseHud(var_name, tc_msg, 9, tc_color[0], tc_color[1], tc_color[2], tc_pos[0], tc_pos[1], tc_effect)
 if (tc_time > 0)
  {
   formatex(tc_var, 63, "%s", var_name)
   if(!task_exists(TASK_TC_MESSAGE)) set_task(1.0, "Message_Task_TC", TASK_TC_MESSAGE, "", 0, "b")
  }
}
//----------------------------------------------------------------------------------
Message_TCHud_Hide()
{
 if(task_exists(TASK_TC_MESSAGE)) remove_task(TASK_TC_MESSAGE)
 
 formatex(tc_var, 63, "")
 
 set_hudmessage (0, 0, 0, -1.0, 0.15, 0, 6.0, 1.0, 0.1, 0.1, CHANNEL_TC)
 show_hudmessage(0, "")
}
//----------------------------------------------------------------------------------
//-----------------------------------[ FORWARDs ]-----------------------------------
//----------------------------------------------------------------------------------
public cw_event_game(msg, arg)
{
 switch(msg)
  {
   case CWE_GAME_INIT:
    {
     Message_VClient(0, "cm_game_init")
     Message_VClient(0, "cm_game_vs_info")
    }
   case CWE_GAME_HALF_INIT:
    {
     if(arg == GAME_HALF_KNIFE)
      {
       Message_VHud(0, "hud_half_knife_init",	CHANNEL_TC)
      }
     else if(arg == GAME_HALF_FIRST)
      {
       Message_VHud(0, "hud_half_first_init",	CHANNEL_TC)
      }
     else if(arg == GAME_HALF_SECOND)	//-- 1st - 2nd Timeout End
      {
       Message_TCHud_Hide()
       Message_VHud(0, "hud_half_second_init",	CHANNEL_TC)
      }
     else if(arg == GAME_HALF_OVERTIME)	//-- Overtime Timeout End
      {
       Message_TCHud_Hide()
       Message_VHud(0, "hud_half_overtime_init",	CHANNEL_TC)
      }
    }
   case CWE_GAME_HALF_STARTED:
    {
     if(arg == GAME_HALF_WARMUP)		//-- Warmup Begin
      {
       Message_TCHud_Show("hud_timeout_warmup")
      }
     else if(arg == GAME_HALF_KNIFE)
      {
       Message_VHud(0, "hud_half_knife_begin", CHANNEL_TC)
       Message_VClient(0, "cm_half_knife")
      }
     else if(arg == GAME_HALF_FIRST)
      {
       Message_VHud(0, "hud_half_first_begin", CHANNEL_TC)
       Message_VClient(0, "cm_half_first")
       Message_VClient(0, "cm_game_gl_hf")
      }
     else if(arg == GAME_HALF_SECOND)
      {
       Message_VHud(0, "hud_half_second_begin", CHANNEL_TC)
       Message_VClient(0, "cm_half_second")
      }
     else if(arg == GAME_HALF_OVERTIME)
      {
       Message_VHud(0, "hud_half_overtime_begin", CHANNEL_TC)
       Message_VClient(0, "cm_half_overtime")
      }
    }
   case CWE_GAME_HALF_END:
    {
     if(arg == GAME_HALF_WARMUP)		//-- Warmup End
      {
       Message_TCHud_Hide()
      }
     else if(arg == GAME_HALF_FIRST)	//-- 1st - 2nd Timeout Begin
      {
       set_task(get_cvar_float("cw_transfer_timeout") + 1, "Message_TCHud_Show", 0, "hud_timeout_half", strlen("hud_timeout_half"))
      }
     else if(arg == GAME_HALF_SECOND)	//-- 2nd - Overtime Timeout Begin
      {
       if(get_cvar_num("cw_overtime") != 0)
        {
         new t_score[2]
         
         t_score[0] = cw_var_get_int(CWV_TEAM_TSCORE, 0)
         t_score[1] = cw_var_get_int(CWV_TEAM_TSCORE, 1)
         
         if(t_score[0] == t_score[1])
           set_task(get_cvar_float("cw_transfer_timeout") + 1, "Message_TCHud_Show", 0, "hud_timeout_overtime_1", strlen("hud_timeout_overtime_1"))
        }
      }
     else if(arg == GAME_HALF_OVERTIME)
      {
       if(cw_var_get_int(CWV_OVERTIME_STATUS) == OVERTIME_HALF_FIRST)
        {
         set_task(get_cvar_float("cw_transfer_timeout") + 1, "Message_TCHud_Show", 0, "hud_timeout_overtime_2", strlen("hud_timeout_overtime_2"))
        }
       else
        {
         new o_score[2]
         
         o_score[0] = cw_var_get_int(CWV_TEAM_HSCORE, 0)
         o_score[1] = cw_var_get_int(CWV_TEAM_HSCORE, 1)
         
         if(o_score[0] == o_score[1])
           set_task(get_cvar_float("cw_transfer_timeout") + 1, "Message_TCHud_Show", 0, "hud_timeout_overtime_1", strlen("hud_timeout_overtime_1"))
        }
      }
    }
   case CWE_GAME_SCORE_CHANGED:
    {
     if(get_pcvar_num(g_cw_score_show) != 0)
      {
       if(arg == 0)	set_task(get_pcvar_float(g_cw_score_timeout), "Message_Task_ScoreInfo") 
       else		Message_Task_ScoreInfo()
      }
    }
   case CWE_GAME_END:
    {
     Message_TCHud_Hide()
     
     if((arg == 0) || (arg == 1))
      {
       win_team = arg
       Message_VHud(0, "hud_game_end", CHANNEL_TC)
       Message_VClient(0, "cm_game_end")
      }
     else
      {
       Message_VHud(0, "hud_game_draw", CHANNEL_TC)
       Message_VClient(0, "cm_game_draw")
      }
    }
   case CWE_GAME_FORCE:
    {
     Message_TCHud_Hide()
     Message_VClient(0, "cm_game_force", arg)
    }
   case CWE_GAME_RESTART:
    {
     Message_TCHud_Hide()
     Message_VClient(0, "cm_game_restart_match", arg)
    }
   case CWE_GAME_RESTART_HALF:
    {
     Message_TCHud_Hide()
     Message_VClient(0, "cm_game_restart_half", arg)
    }
   case CWE_GAME_ABORT:
    {
     Message_TCHud_Hide()
     Message_VClient(0, "cm_game_abort", arg)
    }
  }
 
 return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------
public cw_event_error(msg, id)
{
 switch(msg)
  {
   case CWE_ERROR_INIT_ALREADY:
    {
     (id == 0) ? Message_VServer("cm_error_init_1") : Message_VClient(id, "cm_error_init_1")
    }
   case CWE_ERROR_INIT_PARAMS:
    {
     (id == 0) ? Message_VServer("cm_error_init_2") : Message_VClient(id, "cm_error_init_2")
    }
   case CWE_ERROR_FORCE:
    {
     (id == 0) ? Message_VServer("cm_error_force") : Message_VClient(id, "cm_error_force")
    }
   case CWE_ERROR_RESTART_GAME:
    {
     (id == 0) ? Message_VServer("cm_error_restart_game") : Message_VClient(id, "cm_error_restart_game")
    }
   case CWE_ERROR_RESTART_HALF:
    {
     (id == 0) ? Message_VServer("cm_error_restart_half") : Message_VClient(id, "cm_error_restart_half")
    }
   case CWE_ERROR_ABORT:
    {
     (id == 0) ? Message_VServer("cm_error_abort") : Message_VClient(id, "cm_error_abort")
    }
  }
}
//----------------------------------------------------------------------------------
public cw_event_captain(msg, id, team_side)
{
 if(id == 0) return PLUGIN_CONTINUE
 
 switch(msg)
  {
   case CWE_CAPTAIN_SET:
    {
     Message_VClient(id, "cm_captain")
     Message_VClient(0,  "cm_captain_notify", id, team_side)
    }
   case CWE_CAPTAIN_MARKED:
    {
     Message_VClient(id, "cm_captain_marked")
    }
  }
 
 return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------
public cw_event_ready(msg, id)
{
 switch(msg)
  {
   case CWE_RSYSTEM_READY:
    {
     Message_VClient(id, "cm_ready")
     Message_VClient(0,  "cm_ready_notify", id, -1)
    }
   case CWE_RSYSTEM_READY_MARKED:
    {
     Message_VClient(id, "cm_ready_marked")
    }
   case CWE_RSYSTEM_NOTREADY:
    {
     Message_VClient(id, "cm_notready")
     Message_VClient(0,  "cm_notready_notify", id, -1)
    }
   case CWE_RSYSTEM_NOTREADY_MARKED:
    {
     Message_VClient(id, "cm_notready_marked")
    }
   case CWE_RSYSTEM_READY_ALL:
    {
     if(cw_var_get_int(CWV_GAME_STATUS) == GAME_HALF_WARMUP)
      {
       Message_VClient(0, "cm_ready_all_warmup")
      }
     else
      {
       Message_VClient(0, "cm_ready_all_timeout")
      }
    }
  }
 
 return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------
//-----------------------------------[ HANDLERs ]-----------------------------------
//----------------------------------------------------------------------------------
public Message_Handler_NewRound()
{
 if(cw_var_get_int(CWV_GAME_STATUS) == GAME_HALF_WARMUP)
  {
   set_task(0.5, "Message_Task_WarmupInfo")
  }
}
//----------------------------------------------------------------------------------
//------------------------------[ PLUGIN INIT BEGIN ]-------------------------------
public plugin_init()
{
 register_plugin("ClanWar XT [MESSAGE]", CLAN_WAR_VERSION, CLAN_WAR_AUTHOR)
 
 register_event("HLTV",	"Message_Handler_NewRound",	"a", "1=0", "2=0")
 
 register_clcmd("say_team /score",	"Message_ShowScore")
 
 g_cw_score_show	= register_cvar("cw_score_show",		"1")
 g_cw_score_timeout	= register_cvar("cw_score_timeout",		"5.0")
  
 Message_Load()
}
//-------------------------------[ PLUGIN INIT END ]--------------------------------
//----------------------------------------------------------------------------------
