#include <amxmodx>
#include <cstrike>
#include "include/clanwar_const"
#include "include/clanwar_core"

new g_cw_EventCaptain, g_cw_EventReady, g_cw_EventReturn
new g_cw_ready_timeout, g_cw_ready_min

new bool:captain_active, captain_id[2]
new bool:ready_active, ready_players[2][32], ready_count[2]
new CsTeams:player_team_id[32]

new msg_ready[2][512], msg_total[32]

//----------------------------------------------------------------------------------
//--------------------------------[ CAPTAIN SYSTEM ]--------------------------------
//----------------------------------------------------------------------------------
Captain_Init()
{
 captain_id[0]	= cw_var_get_int(CWV_TEAM_CAPTAIN, 0)
 captain_id[1]	= cw_var_get_int(CWV_TEAM_CAPTAIN, 1)
 captain_active	= true
}
//----------------------------------------------------------------------------------
Captain_End()
{
 captain_active = false
}
//----------------------------------------------------------------------------------
public Captain_Set(id)
{
 if(!captain_active) return PLUGIN_CONTINUE
 //--
 new CsTeams:team_id, team_side
 
 team_id = cs_get_user_team(id)
 if(!cw_get_team_side(team_id, team_side)) return PLUGIN_CONTINUE
 
 if(captain_id[team_side] != id)
  {
   captain_id[team_side] = id
   cw_var_set_int(CWV_TEAM_CAPTAIN, captain_id[team_side], team_side)
   ExecuteForward(g_cw_EventCaptain, g_cw_EventReturn, CWE_CAPTAIN_SET,    captain_id[team_side], team_side)
  }
 else
  {
   ExecuteForward(g_cw_EventCaptain, g_cw_EventReturn, CWE_CAPTAIN_MARKED, captain_id[team_side], team_side)
  }
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
bool:Captain_Unset(id, team_side)
{
 if(!captain_active) return false
 //--
 new team_players[32], team_count
 if(captain_id[team_side] == id)
  {
   new captain_new = id
   
   get_players(team_players, team_count, "ce", (team_side == 0) ? "CT":"TERRORIST")
   
   if(team_count > 0)
    {
     for(new i = 0; i < team_count; i++)
       if(team_players[i] != id)
        {
         captain_new = team_players[i]
         break
        }
     
     if(captain_new != id)
      {
       Captain_Set(captain_new)
       return true
      }
    }
   
   captain_id[team_side] = 0
   cw_var_set_int(CWV_TEAM_CAPTAIN, 0, team_side)
   ExecuteForward(g_cw_EventCaptain, g_cw_EventReturn, CWE_CAPTAIN_SET, 0, team_side)
  }
 
 return true
}
//----------------------------------------------------------------------------------
//---------------------------------[ READY SYSTEM ]---------------------------------
//----------------------------------------------------------------------------------
RSystem_Init()
{
 ready_count	= {0, 0}
 ready_active	= true
}
//----------------------------------------------------------------------------------
RSystem_End()
{
 RSystem_Hide()
 ready_active	= false
}
//----------------------------------------------------------------------------------
RSystem_UpdateMsg()
{
 new player_name[32], player_team[2][32]
 
 //--
 if(get_cvar_num("cw_clantag") != 0)
  {
   cw_var_get_str(CWV_TEAM_NAME, player_team[0], 31, 0)
   cw_var_get_str(CWV_TEAM_NAME, player_team[1], 31, 1)
   
   formatex(msg_ready[0], 511, "%s:", player_team[0])
   formatex(msg_ready[1], 511, "%s:", player_team[1])
  }
 else
  {
   formatex(msg_ready[0], 511, "Counter-Terrorists:")
   formatex(msg_ready[1], 511, "Terrorists:")
  }
 //--
 
 for(new t = 0; t < 2; t++)
   for(new i = 0; i < ready_count[t]; i++)
    {
     get_user_name(ready_players[t][i], player_name, 31)
     
     cw_trim_user_name(player_name, 31, player_team[t])
     
     if(i == 0)	format(msg_ready[t], 511, "%s %s",	msg_ready[t], player_name)
     else		format(msg_ready[t], 511, "%s, %s",	msg_ready[t], player_name)
    }
 
 //-- TOTAL
 formatex(msg_total, 31, "Total: %d/%d", ready_count[0] + ready_count[1], get_pcvar_num(g_cw_ready_min) * 2)
}
//----------------------------------------------------------------------------------
public RSystem_Draw()
{
 if(!ready_active) return PLUGIN_CONTINUE
 //--
 new bool:have_ct = (ready_count[0] > 0) ? true : false
 
 //-- CT
 if(ready_count[0] > 0)
  {
   set_hudmessage (0, 50, 250, 0.003, 0.24, 0, 6.0, 2.0, 0.2, 0.2, CHANNEL_READY_LINE1)
   show_hudmessage(0, msg_ready[0])
  }
 //-- T
 if(ready_count[1] > 0)
  {
   set_hudmessage (250, 25, 25, 0.003, have_ct ? 0.24 : 0.27, 0, 6.0, 2.0, 0.2, 0.2, have_ct ? CHANNEL_READY_LINE1 : CHANNEL_READY_LINE2)
   show_hudmessage(0, msg_ready[1])
  }
 //-- TOTAL
 if((ready_count[0] + ready_count[1]) > 0)
  {
   set_hudmessage (200, 50,  0, 0.003, have_ct ? 0.27 : 0.30, 0, 6.0, 2.0, 0.2, 0.2, have_ct ? CHANNEL_READY_LINE2 : CHANNEL_READY_LINE3)
   show_hudmessage(0, msg_total)
  }
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
RSystem_Show()
{
 if(!task_exists(TASK_READY_INFO)) set_task(1.0, "RSystem_Draw", TASK_READY_INFO, "", 0, "b")
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
RSystem_Hide()
{
 if(task_exists(TASK_READY_INFO)) remove_task(TASK_READY_INFO)
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
public RSystem_SetReady(id)
{
 if(!ready_active) return PLUGIN_CONTINUE
 //---
 new CsTeams:team_id, team_side
 
 team_id = cs_get_user_team(id)
 if(!cw_get_team_side(team_id, team_side)) return PLUGIN_CONTINUE
 
 for(new i = 0; i < ready_count[team_side]; i++)
  if(ready_players[team_side][i] == id)
   {
    ExecuteForward(g_cw_EventReady, g_cw_EventReturn, CWE_RSYSTEM_READY_MARKED, id)
    return PLUGIN_HANDLED
   }
 
 ready_players[team_side][ready_count[team_side]] = id
 ready_count[team_side]++
 
 ExecuteForward(g_cw_EventReady, g_cw_EventReturn, CWE_RSYSTEM_READY, id)
 
 RSystem_UpdateMsg()
 RSystem_Show()
 //---
 new min_ready = get_pcvar_num(g_cw_ready_min)
 if((ready_count[0] >= min_ready) && (ready_count[1] >= min_ready))
  {
   ExecuteForward(g_cw_EventReady, g_cw_EventReturn, CWE_RSYSTEM_READY_ALL, 0)
   cw_game_change()
  }
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
bool:RSystem_UnsetReady(id, team_side)
{
 if(!ready_active) return false
 //--
 for(new i = 0; i < ready_count[team_side]; i++)
   if(ready_players[team_side][i] == id)
    {
     for(new j = i; j < (ready_count[team_side]-1); j++) ready_players[team_side][j] = ready_players[team_side][j+1]
     
     ready_count[team_side]--
     RSystem_UpdateMsg()
     return true
    }
 
 return false
}
//----------------------------------------------------------------------------------
public RSystem_SetNotReady(id)
{
 if(!ready_active) return PLUGIN_CONTINUE
 //--
 new CsTeams:team_id, team_side
 
 team_id = cs_get_user_team(id)
 if(!cw_get_team_side(team_id, team_side)) return PLUGIN_CONTINUE
 
 if(!RSystem_UnsetReady(id, team_side))
  {
   ExecuteForward(g_cw_EventReady, g_cw_EventReturn, CWE_RSYSTEM_NOTREADY_MARKED, id)
  }
 else
  {
   ExecuteForward(g_cw_EventReady, g_cw_EventReturn, CWE_RSYSTEM_NOTREADY, id)
   RSystem_Show()
  }
 
 return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------
//-----------------------------------[ FORWARDs ]-----------------------------------
//----------------------------------------------------------------------------------
public cw_event_game(msg, arg)
{
 switch(msg)
  {
   case CWE_GAME_HALF_INIT:
    {
     if((arg != GAME_HALF_WARMUP) && (arg != GAME_HALF_KNIFE))	//-- Timeout End
      {
       if(ready_active)	RSystem_End()
      }
    }
   case CWE_GAME_HALF_BEGIN:
    {
     if(arg == GAME_HALF_WARMUP)					//-- Warmup Begin
      {
       if(get_cvar_num("cw_assign_mode") == 1) Captain_Init()
       RSystem_Init()
      }
    }
   case CWE_GAME_HALF_END:
    {
     if(arg == GAME_HALF_WARMUP)					//-- Warmup End
      {
       if(captain_active)	Captain_End()
       if(ready_active)	RSystem_End()
      }
     else if(arg != GAME_HALF_KNIFE)				//-- Timeout Begin
      {
       if(get_pcvar_num(g_cw_ready_timeout) != 0) RSystem_Init()
      }
    }
   case CWE_GAME_RESTART, CWE_GAME_RESTART_HALF:
    {
     if(captain_active)
      {
       Captain_End()
       if(get_cvar_num("cw_assign_mode") == 1) Captain_Init()
      }
     
     if(ready_active)
      {
       RSystem_End()
       RSystem_Init()
      }
    }
   case CWE_GAME_END, CWE_GAME_ABORT:
    {
     if(captain_active)	Captain_End()
     if(ready_active)	RSystem_End()
    }
  }
 
 return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------
public client_connect(id)
{
 if(!is_user_hltv(id) && !is_user_bot(id) && id > 0) player_team_id[id-1] = CS_TEAM_UNASSIGNED
 return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------
public client_disconnect(id)
{
 if(is_user_hltv(id) || is_user_bot(id)) return PLUGIN_CONTINUE
 //--
 new CsTeams:team_id, team_side
 
 team_id = cs_get_user_team(id)
 if(!cw_get_team_side(team_id, team_side)) return PLUGIN_CONTINUE
 
 player_team_id[id-1] = CS_TEAM_UNASSIGNED
 
 Captain_Unset(id, team_side)
 RSystem_UnsetReady(id, team_side)
 
 return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------
public client_infochanged(id)
{
 if(is_user_hltv(id) || is_user_bot(id) || id < 1) return PLUGIN_CONTINUE
 
 new CsTeams:team_id_new, CsTeams:team_id_old
 new team_side_new, team_side_old
 
 team_id_new		= cs_get_user_team(id)
 team_id_old		= player_team_id[id-1]
 team_side_new	= (team_id_new == CS_TEAM_CT) ? 0:1
 team_side_old	= (team_id_old == CS_TEAM_CT) ? 0:1
 
 if(team_id_new != team_id_old)
  {
   RSystem_UnsetReady(id, team_side_old)
   
   if((team_id_old == CS_TEAM_UNASSIGNED) || (team_id_old == CS_TEAM_SPECTATOR))
    {
     if((team_id_new == CS_TEAM_CT) || (team_id_new == CS_TEAM_T))
       if(captain_id[team_side_new] == 0) Captain_Set(id)
    }
   else
    {
     Captain_Unset(id, team_side_old)
     if((team_id_new == CS_TEAM_CT) || (team_id_new == CS_TEAM_T))
       if(captain_id[team_side_new] == 0) Captain_Set(id)
    }
   
   player_team_id[id-1] = team_id_new
  }
 
 if((ready_active == true) && (team_id_new == team_id_old) && ((team_id_new == CS_TEAM_CT) || (team_id_new == CS_TEAM_T)))
  {
   new player_name_new[32], player_name_old[32]
   
   get_user_info(id, "name",	player_name_new, 31)
   get_user_name(id,			player_name_old, 31)
   
   if(equal(player_name_new, player_name_old) == 0) RSystem_UpdateMsg()
  }
 
 return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------
//------------------------------[ PLUGIN INIT BEGIN ]-------------------------------
public plugin_init()
{
 register_plugin("ClanWar XT [READY]", CLAN_WAR_VERSION, CLAN_WAR_AUTHOR)
 
 g_cw_EventCaptain	= CreateMultiForward("cw_event_captain",	ET_IGNORE, FP_CELL, FP_CELL, FP_CELL)
 g_cw_EventReady	= CreateMultiForward("cw_event_ready",	ET_IGNORE, FP_CELL, FP_CELL)
 
 register_clcmd("say captain",	"Captain_Set")
 register_clcmd("say ready",		"RSystem_SetReady")
 register_clcmd("say notready",	"RSystem_SetNotReady")
 
 g_cw_ready_timeout	= register_cvar("cw_ready_timeout",		"1") //-- 1 - Enable ready systen in timeout  0 - Disable
 g_cw_ready_min	= register_cvar("cw_ready_min",		"5")
 
 captain_active	= false
 captain_id		= {0, 0}
 ready_active		= false
 ready_count		= {0, 0}
}
//----------------------------------------------------------------------------------
public plugin_end()
{
 DestroyForward(g_cw_EventCaptain)
 DestroyForward(g_cw_EventReady)
}
//-------------------------------[ PLUGIN INIT END ]--------------------------------
//----------------------------------------------------------------------------------
