#if defined _cw_const_included
  #endinput
#endif
#define _cw_const_included


#define CLAN_WAR_VERSION		"2.17"
#define CLAN_WAR_AUTHOR			"Rostislav Olitto [n0pe] <RUS>"

#define TIMEOUT_ROUND_START		6.0
#define TIMEOUT_HALF_INIT		5.0

#define TASK_TIMEOUT_TIMER		888000
#define TASK_READY_INFO			888001
#define TASK_TC_MESSAGE			888002
#define TASK_HLTV_DISCONNECT		888003

#define CHANNEL_READY_LINE1		20
#define CHANNEL_READY_LINE2		21
#define CHANNEL_READY_LINE3		22
#define CHANNEL_TC			23

/***********************************************************************
   game_status
***********************************************************************/
#define GAME_NULL			-1
#define GAME_HALF_WARMUP		0
#define GAME_HALF_KNIFE			1
#define GAME_HALF_FIRST			2
#define GAME_HALF_SECOND		3
#define GAME_HALF_OVERTIME		4

/***********************************************************************
   half_status
***********************************************************************/
#define HALF_NULL			-1
#define HALF_INACTIVE			0
#define HALF_ACTIVE			1

/***********************************************************************
   overtime_status
***********************************************************************/
#define OVERTIME_NULL			-1
#define OVERTIME_HALF_FIRST		0
#define OVERTIME_HALF_SECOND		1

/***********************************************************************
   native cw_var_get_int[str], cw_var_set_int[str]
***********************************************************************/
#define CWV_GAME_STATUS			101
#define CWV_HALF_STATUS			102
#define CWV_OVERTIME_STATUS		103
#define CWV_HALF_NUMBER			104
#define CWV_TEAM_NAME			105
#define CWV_TEAM_CAPTAIN		106
#define CWV_TEAM_TSCORE			107
#define CWV_TEAM_HSCORE			108
#define CWV_TEAM_SIDE			109
#define CWV_TIMEOUT_TIME		110

/***********************************************************************
   public cw_event_game(msg, arg)
***********************************************************************/
#define CWE_GAME_INIT			1
#define CWE_GAME_HALF_INIT		2
#define CWE_GAME_HALF_BEGIN		3
#define CWE_GAME_HALF_STARTED		4
#define CWE_GAME_HALF_END		5
#define CWE_GAME_SCORE_CHANGED		6
#define CWE_GAME_END			7
#define CWE_GAME_FORCE			8
#define CWE_GAME_RESTART		9
#define CWE_GAME_RESTART_HALF		10
#define CWE_GAME_ABORT			11

/***********************************************************************
   public cw_event_error(msg, id)
***********************************************************************/
#define CWE_ERROR_INIT_ALREADY		1
#define CWE_ERROR_INIT_PARAMS		2
#define CWE_ERROR_FORCE			3
#define CWE_ERROR_RESTART_GAME		4
#define CWE_ERROR_RESTART_HALF		5
#define CWE_ERROR_ABORT			6


/***********************************************************************
   public cw_event_captain(msg, id, team_side)
***********************************************************************/
#define CWE_CAPTAIN_SET			1
#define CWE_CAPTAIN_MARKED		2

/***********************************************************************
   public cw_event_ready(msg, id)
***********************************************************************/
#define CWE_RSYSTEM_READY		10
#define CWE_RSYSTEM_READY_MARKED	15
#define CWE_RSYSTEM_NOTREADY		20
#define CWE_RSYSTEM_NOTREADY_MARKED	25
#define CWE_RSYSTEM_READY_ALL		30
